//+------------------------------------------------------------------+
//|                                                LBR_RSI proba.mq4 |
//|                                        Copyright  2008, Rone_IS |
//|                                            rone.sergey@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Rone_IS"
#property link      "rone.sergey@gmail.com"

//----  
//----     My_orders.mqh      MAGIC
extern int MAGIC=20080710;
extern int Momentum_Period=1;
extern int RSI_Period = 3;
extern int StopLoss=50;
extern int TakeProfit=100;
extern double Lot=0.5;
extern int Slippage=0;
extern int CloseAfterBars = 5;


string ExpertName="LBR_RSI";
//---- -   
int CalculateCurrentOrders(string symbol)
   {
   int buys=0, sells=0;
   
   for (int i=0; i<OrdersTotal(); i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
         {
         if (OrderType()==OP_BUY) buys++;
         if (OrderType()==OP_SELL) sells++;
         }
      }
   if (buys>0) return(buys);
   else        return(sells);
   }
   
//----    
void CheckForOpen()
   {
   int ticket;
   double size,SL,TP;
   double LBR1, LBR2;
   
   if (Volume[0]>2) return;
   
   LBR1=iCustom(NULL,0,"LBR_RSI",Momentum_Period,RSI_Period,0,1);
   LBR2=iCustom(NULL,0,"LBR_RSI",Momentum_Period,RSI_Period,0,2);
   
   if (LBR1>30 && LBR2<30)
      {
      size=Lot; 
      RefreshRates();
      SL=Ask-StopLoss*Point;
      TP=Ask+TakeProfit*Point;
      ticket=OrderSend(Symbol(),OP_BUY,size,Ask,Slippage,SL,TP,ExpertName,MAGIC,0,Blue);
      if (ticket<0)
         Print("BUY OrderSend ERROR: #",GetLastError());
      PlaySound("ok.wav");
      return;
      }
      
   if (LBR1<70 && LBR2>70)
      {
      size=Lot; 
      RefreshRates();
      SL=Bid+StopLoss*Point;
      TP=Bid-TakeProfit*Point;
      ticket=OrderSend(Symbol(),OP_SELL,size,Bid,Slippage,SL,TP,ExpertName,MAGIC,0,Red);
      if (ticket<0)
         Print("SELL OrderSend ERROR: #",GetLastError());
      PlaySound("ok.wav");
      return;
      }            
   }  
   
//----       
void CheckForClose()
   {
   bool res;
   double LBR1,LBR2;
   
   if (Volume[0]>2) return;
   
   LBR1=iCustom(NULL,0,"LBR_RSI",Momentum_Period,RSI_Period,0,1);
   LBR2=iCustom(NULL,0,"LBR_RSI",Momentum_Period,RSI_Period,0,2);  
   
   //----
   for (int i=0; i<OrdersTotal(); i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)      break;
      if (OrderSymbol()!=Symbol() || OrderMagicNumber()!=MAGIC) continue;
      
      if (OrderType()==OP_BUY)
         {
         //   
         if (LBR1<70 && LBR2>70 || iBarShift(NULL,0,OrderOpenTime(),false)==CloseAfterBars)
            res=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Orange);
         break;
         }
         
      if (OrderType()==OP_SELL)
         {
         //   
         if (LBR1>30 && LBR2<30 || iBarShift(NULL,0,OrderOpenTime(),false)==CloseAfterBars)
            res=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Orange);
         break;
         }
      }      
   }
   
//----
void start()
   {
   if (Bars<100 || IsTradeAllowed()==false) return;
   
   if (CalculateCurrentOrders(Symbol())==0)
      CheckForOpen();
   else
      CheckForClose();
   }   